varying vec3 vColor;uniform sampler2D uFrontCoords;uniform sampler2D uPreviousStage;uniform vec2 uViewportSize;uniform sampler2D uLabelMapLUT;uniform float uLabelMapLUTlength;uniform SAMPLER_3D uLabelMap;uniform SAMPLER_3D uVolume;vec4 getlblavg(vec3 start,vec3 end,float stopLengthRatio) {vec3 ray=start;vec3 direction=end-start;float stopLength=stopLengthRatio*length(direction);vec3 rayIncrement=sqrt(3.0)/float(STEPS)*normalize(direction);int lastStep=int(stopLength/length(rayIncrement));vec4 avg=vec4(0,0,0,0);for (int i=0; i<STEPS; i++) {avg+=texture3DNearestLUT(uLabelMap,ray,uLabelMapLUT,uLabelMapLUTlength);ray+=rayIncrement;if (i>=lastStep) {break;}
}
avg/=float(STEPS);return avg;}
const float unselectedLabelAlpha=100.0/255.0;const float maxFillingFactor=0.4;void main() {vec4 prev=LABEL_PREVIOUS_FRAG_COLOR;vec3 start=LABEL_FRONT_COORDS;vec3 end=vColor;vec3 direction=end-start;float depth=prev.b;vec4 lblavg=getlblavg(start,end,depth);float alpha=lblavg.a*depth;alpha/=unselectedLabelAlpha;alpha/=maxFillingFactor;if (depth<0.9) {vec3 voxelStep=2.0*normalize(direction)*1.0/uVolumeSize;vec3 volumeColor
=intensityToColor(texture3D(uVolume,start+depth*direction+voxelStep).r).rgb;gl_FragColor=vec4(mix(volumeColor,lblavg.rgb,alpha),1);} else {gl_FragColor=vec4(alpha*lblavg.rgb,alpha);}
}
